using System.Collections.Generic;
using Common;

namespace SalesDomain
{
  public class Customer : Contact
  {
    //this is not a fully fleshed out
    //aggregate root and NOT designed to be copy/pasted
    //as example code in your apps.
    //Please focus on features
    //that are discussed in August 2013 Data Points column
    public Customer(string firstName,string lastName, string email)
    {
      FullName = new FullName(firstName,lastName);
      EmailAddress = email;
      Status = CustomerStatus.Silver;
    }
   
    internal Customer()
    {
    }

    public void CopyBillingAddressToShippingAddress()
    {
      ShippingAddress = new Address
                          {
                            Street1 = BillingAddress.Street1,
                            City = BillingAddress.City,
                            PostalCode = BillingAddress.PostalCode
                          };
    }
    
    public void CreateNewShippingAddress(string street, string city, string zip)
    {
     BillingAddress = new Address
                        {
                          Street1 = street, 
                          City = city,
                          PostalCode = zip
                        };
    }

    public void CreateBillingInformation(string street, string city, string zip,
                                         string creditcardNumber, string bankName)
    {
      BillingAddress = new Address {Street1 = street, City = city, PostalCode = zip};
      CreditCard = new CustomerCreditCard {Bank = bankName, Number = creditcardNumber};
    }
    
    public void SetCustomerContactDetails(string email, string phone,
                                          string companyName)
   {
     EmailAddress = email;
     Phone = phone;
     CompanyName = companyName;

   }

    public string SalesPersonId { get; private set; }
    public CustomerStatus Status{get;private set;}
    public Address ShippingAddress { get; private set; }
    public Address BillingAddress { get;private set; }
    public CustomerCreditCard CreditCard { get; private set; }
  }

  public enum CustomerStatus
  {
    Silver=1,
    Gold=2,
    Platinum=3
  }
}





